-- new table to hold the persons/users who can use the application
CREATE TABLE person(
	personid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	uuid VARCHAR(36) NOT NULL,
	created TIMESTAMP NOT NULL,
	updated TIMESTAMP,
	username VARCHAR(128) NOT NULL,
	name VARCHAR(128) NOT NULL,
	password VARCHAR(128),
	active BOOLEAN,
	businessid BIGINT,	
	PRIMARY KEY(personid),
	CONSTRAINT fk_person_businessid FOREIGN KEY(businessid) REFERENCES PUBLIC.business(businessid)
)

-- add one person (admin) to the business
INSERT INTO person(uuid,created,username,name,password,active,businessid) SELECT business.uuid,business.created,'admin','Admin','',TRUE,business.businessid FROM business;

-- set the default user to clients
ALTER TABLE client ADD creatorid BIGINT;
ALTER TABLE client ADD CONSTRAINT fk_client_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE client SET creatorid=1;

-- set the default user to projects
ALTER TABLE project ADD creatorid BIGINT;
ALTER TABLE project ADD CONSTRAINT fk_project_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE project SET creatorid=1;

-- set the default user to tasks
ALTER TABLE task ADD creatorid BIGINT;
ALTER TABLE task ADD CONSTRAINT fk_task_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE task SET creatorid=1;

-- set the default user to task categories
ALTER TABLE taskcategory ADD creatorid BIGINT;
ALTER TABLE taskcategory ADD CONSTRAINT fk_taskcategory_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE taskcategory SET creatorid=1;

-- set the default user to time entries
ALTER TABLE timeentry ADD creatorid BIGINT;
ALTER TABLE timeentry ADD CONSTRAINT fk_timeentry_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE timeentry SET creatorid=1;

-- set the default user to expenses
ALTER TABLE expense ADD creatorid BIGINT;
ALTER TABLE expense ADD CONSTRAINT fk_expense_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE expense SET creatorid=1;

-- set the default user to expense categories
ALTER TABLE expensecategory ADD creatorid BIGINT;
ALTER TABLE expensecategory ADD CONSTRAINT fk_expensecategory_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE expensecategory SET creatorid=1;

-- set the default user to trips
ALTER TABLE trip ADD creatorid BIGINT;
ALTER TABLE trip ADD CONSTRAINT fk_trip_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE trip SET creatorid=1;

-- set the default user to trip rates
ALTER TABLE triprate ADD creatorid BIGINT;
ALTER TABLE triprate ADD CONSTRAINT fk_triprate_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE triprate SET creatorid=1;

-- set the default user to products
ALTER TABLE product ADD creatorid BIGINT;
ALTER TABLE product ADD CONSTRAINT fk_product_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE product SET creatorid=1;

-- set the default user to catalog items
ALTER TABLE catalogitem ADD creatorid BIGINT;
ALTER TABLE catalogitem ADD CONSTRAINT fk_catalogitem_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE catalogitem SET creatorid=1;

-- set the default user to deposits
ALTER TABLE deposit ADD creatorid BIGINT;
ALTER TABLE deposit ADD CONSTRAINT fk_deposit_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE deposit SET creatorid=1;

-- set the default user to invoices
ALTER TABLE invoice ADD creatorid BIGINT;
ALTER TABLE invoice ADD CONSTRAINT fk_invoice_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE invoice SET creatorid=1;

-- set the default user to items
ALTER TABLE item ADD creatorid BIGINT;
ALTER TABLE item ADD CONSTRAINT fk_item_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE item SET creatorid=1;

-- set the default user to payments
ALTER TABLE payment ADD creatorid BIGINT;
ALTER TABLE payment ADD CONSTRAINT fk_payment_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE payment SET creatorid=1;

-- set the default user to tax groups
ALTER TABLE taxgroup ADD creatorid BIGINT;
ALTER TABLE taxgroup ADD CONSTRAINT fk_taxgroup_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE taxgroup SET creatorid=1;

-- set the default user to taxes
ALTER TABLE tax ADD creatorid BIGINT;
ALTER TABLE tax ADD CONSTRAINT fk_tax_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid);
UPDATE tax SET creatorid=1;
